-- Based on "DCS - Simple Range Script" By Ciribob

trigger.action.outText( 'Runway script loaded', 10 )
-- env.info("Runway Script Loaded")

range  = {}
range.bombingMinAlt = 0
range.RunHit = 0
range.RunWid = 25


-- Handles all world events
range.eventHandler = {}
function range.eventHandler:onEvent(_eventDCS)

    if _eventDCS == nil or _eventDCS.initiator == nil then
        return true
    end


    local status, err = pcall(function(_event)


        if _event.id == world.event.S_EVENT_SHOT then

            local _weapon = _event.weapon:getTypeName()
            local _weaponStrArray = range.split(_weapon,"%.")

            local _weaponName = _weaponStrArray[#_weaponStrArray]
            if (string.match(_weapon, "weapons.bombs") --all bombs
                    or string.match(_weapon, "weapons.nurs") --all rockets

				)
            then
                local Runway1 = trigger.misc.getZone("R1")
                local Runway2 = trigger.misc.getZone("R2")
                local x1 = Runway1.point.x
                local z1 = Runway1.point.z
                local x2 = Runway2.point.x
                local z2 = Runway2.point.z
                local Rlen = range.getDistance(Runway1.point,Runway2.point)
                                
                -- env.info("Runway Length"..Rlen)
                -- env.info("Runway1"..x1.." "..z1)
                -- env.info("Runway2"..x2.." "..z2)

                
                local _ordnance =  _event.weapon
                -- env.info("Tracking ".._weapon.." - ".._ordnance:getName())
                local _lastBombPos = {x=0,y=0,z=0}
                
                local _unitName = _event.initiator:getName()
                local trackBomb = function(_previousPos)
                    local _unit = Unit.getByName(_unitName)
                    --    env.info("Checking...")
                    if _unit ~= nil and _unit:getPlayerName() ~= nil then
                        -- when the pcall returns a failure the weapon has hit
                        local _status,_bombPos =  pcall(function()
                            -- env.info("protected")
                            return _ordnance:getPoint()
                        end)
                        if  _status then
                            --ok! still in the air
                            _lastBombPos = {x = _bombPos.x, y = _bombPos.y, z= _bombPos.z }
                            return timer.getTime() + 0.005 -- check again !
                        else
                            --hit
                          -- env.info("Hit!")
                            -- Routine to calculate distance from bomb strike to runway centre line
                              -- Get x1, z1 and x2, z2 - coordinates of R1 and R1 - see above
                              -- Get px, pz, coordinates of bomb
                          local px = _lastBombPos.x
                          local pz = _lastBombPos.z
                               -- Calculate length of Runway RLen = Sqrt[(x1-x2)^2 + (z1-z2)^2] - See Above
                               -- Calculate u = (((px - x1) * (x2 - x1)) + ((pz - z1) * (z2 - z1)))
                          local u = (((px - x1) * (x2 - x1)) + ((pz - z1) * (z2 - z1)))                      
                               -- Calculated u = u/RLen^2
                              u = u/(Rlen * Rlen)
                                -- If u <0.000001 or u>1 Then no Hit
                          if u >= 0.0001 or u <= 1 then                          
                                -- Calculate Point on Line lx = x1 + u * (x2 - x1); lz = (z2-z1)
                            local lx = x1 + u * (x2 - x1)
                            local lz = z1 + u * (z2-z1)
                            local DistToRunway = math.sqrt((lx-px)*(lx-px) + (lz-pz)*(lz-pz))
                                -- Calculate distance to line = sqrt[(px-lx)^2 + (pz - lz)^2)]
                                -- If distance < RunWidth then hit
                                 -- Else NoHit
                            -- env.info("Distance to Runway "..DistToRunway)
                            if DistToRunway <= range.RunWid then 
                              range.RunHit = range.RunHit + 1
                              trigger.action.setUserFlag('11',range.RunHit)
                              trigger.action.setUserFlag('10',range.RunHit*15)
                              trigger.action.outText( 'Runway Hit', 10 )
                              -- env.info("Runway Hit ".." "..range.RunHit)
                            end
                          end
                        end
                    end
                    return
                end
                timer.scheduleFunction(trackBomb, nil, timer.getTime() + 1)
            end
        end
        return true
    end, _eventDCS)

    if (not status) then
        env.error(string.format("Error while handling event %s", err),false)
    end
end


range.addedTo = {}

--get distance in meters assuming a Flat world
function range.getDistance(_point1, _point2)

    local xUnit = _point1.x
    local yUnit = _point1.z
    local xZone = _point2.x
    local yZone = _point2.z

    local xDiff = xUnit - xZone
    local yDiff = yUnit - yZone
    return math.sqrt(xDiff * xDiff + yDiff * yDiff)
end

--http://stackoverflow.com/questions/1426954/split-string-in-lua
function range.split(str, sep)
    local result = {}
    local regex = ("([^%s]+)"):format(sep)
    for each in str:gmatch(regex) do
        table.insert(result, each)
    end
    return result
end

--init

range.strafeStatus = {}
range.strafePlayerResults = {}
range.bombPlayerResults = {}
range.planes = {}



world.addEventHandler(range.eventHandler)

